module CrossSpec
  class Config
    def client
      return @client if defined?(@client)
      self.client = Client.new(KafkaClient.new(kafka), handlers)
      @client
    end

    def handlers
      @handlers ||= {}
    end

    def kafka_connection_string
      return @kafka_connection_string if defined?(@kafka_connection_string)
      self.kafka_connection_string = "localhost"
      @kafka_connection_string
    end

    attr_writer :client, :handlers

    def kafka_connection_string=(value)
      @kafka_connection_string = value
      @kafka = Kafka.new(seed_brokers: @kafka_connection_string)
      value
    end

    private

    def kafka
      @kafka ||= Kafka.new(seed_brokers: kafka_connection_string)
    end
  end
end
