module CrossSpec
  class KafkaClient
    TOPIC = "cross-spec.messages"
    def initialize(kafka)
      @kafka = kafka
    end

    def broadcast(str)
      @kafka.deliver_message(str, topic: TOPIC)
    end

    def each_message(&block)
      consumer = @kafka.consumer(group_id: group_id)
      consumer.subscribe(TOPIC)
      consumer.each_message(&block)
    end

    def group_id
      @group_id ||= "cross-spec-#{SecureRandom.hex}"
    end
  end
end
